package bbuvajava;

import java.util.ArrayList;
import java.util.Observable;
import java.util.List;
import java.io.Serializable;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.CascadeType;
import javax.persistence.ManyToMany;
import javax.persistence.OneToMany;
import javax.persistence.Transient;

@Entity
public class Caja extends Observable implements Serializable {

    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long id;

    protected double efectivo;

    protected int idCaja;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.AD092583-8215-B46F-CCAD-F83981D3B5C8]
    // </editor-fold>
    @ManyToMany(cascade=CascadeType.ALL)
    protected List<Movimiento> movimientos;

    @OneToMany(cascade=CascadeType.ALL)
    private List<Arqueo> arqueos;

    @Transient
    private Arqueo ArqueoActual;

    @Transient
    private Empleado emp;

    @ManyToMany(cascade=CascadeType.ALL)
    private List<ingresoCentral> movCentral;

    @Transient
    private ArrayList<Long> billetes;

    double monedas;

    int efectivoFinal;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.028EEFBC-EB33-D2DC-B9D0-EA4EF5783D1C]
    // </editor-fold>

    public Caja () {



        movimientos = new ArrayList<Movimiento>();
        arqueos = new ArrayList<Arqueo>();
        movCentral = new ArrayList<ingresoCentral>();
        billetes = new ArrayList<Long>(7);
        efectivo = 0;
        monedas = 0;
        efectivoFinal = 0;

    }

    public Caja (int auxid) {
        movimientos = new ArrayList<Movimiento>();
        this.idCaja = auxid;
        movCentral = new ArrayList<ingresoCentral>();
        efectivo = 0;
        arqueos = new ArrayList<Arqueo>();
        ArqueoActual = new Arqueo();
        billetes = new ArrayList<Long>(7);
        monedas = 0;
        efectivoFinal = 0;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.2EEE0DDA-1B33-76D9-4D94-34DDE1C7DF19]
    // </editor-fold> 
    public double getEfectivo () {
        return efectivo;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.78464DE8-6F70-4B38-4F71-19775268E0E9]
    // </editor-fold> 
    public void setEfectivo (Double val) {
        this.efectivo += val;
        setChanged();
        notifyObservers();
    }
    public List<Movimiento> getMovimientos() {
        return movimientos;
    }

    public void setMovimientos(List<Movimiento> movimientos) {
        this.movimientos = movimientos;
    }

    public void nuevoMovimiento(Movimiento m){
        this.movimientos.add(m);

    }

    /**
     * @return the emp
     */
    public Empleado getEmp() {
        return emp;
    }

    /**
     * @param emp the emp to set
     */
    public void setEmp(Empleado emp) {
        this.emp = emp;
    }

    /**
     * @return the arqueos
     */
    public List<Arqueo> getArqueos() {
        return arqueos;
    }

    /**
     * @param arqueos the arqueos to set
     */
    public void setArqueos(ArrayList<Arqueo> arqueos) {
        this.arqueos = arqueos;
    }
    public void nuevoArqueo(Arqueo a){
        this.arqueos.add(a);
    }
    public Arqueo getArqueoActual() {
        return ArqueoActual;
    }

    /**
     * @return the movCentral
     */
    public List<ingresoCentral> getMovCentral() {
        return movCentral;
    }

    /**
     * @param movCentral the movCentral to set
     */
    public void setMovCentral(List<ingresoCentral> movCentral) {
        this.movCentral = movCentral;
    }

    public void nuevoMovCentral(ingresoCentral movCent) {
        this.movCentral.add(movCent);
    }

    /**
     * @return the id
     */
    public int getIdCaja() {
        return idCaja;
    }

    /**
     * @param id the id to set
     */
    public void setIdCaja(int id) {
        this.idCaja = id;
    }

    public void  dividirBilletes(double importe){
        Double cantidad;
        this.billetes.add(6, (long)importe/500);
        cantidad = importe%500;
        this.billetes.add(5, (long)(cantidad/200));
        cantidad = cantidad % 200;
        this.billetes.add(4, (long)(cantidad/100));
        cantidad = cantidad % 100;
        this.billetes.add(3, (long)(cantidad/50));
        cantidad = cantidad % 50;
        this.billetes.add(2, (long)(cantidad/20));
        cantidad = cantidad % 20;
        this.billetes.add(1, (long)(cantidad/10));
        cantidad = cantidad % 10;
        this.billetes.add(0, (long)(cantidad/5));
        this.monedas = cantidad % 5;




    }
public  void setArqueoActual(Arqueo ArqueoActual) {
        this.ArqueoActual = ArqueoActual;
    }

 //********************Persistencia************************//
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Caja)) {
            return false;
        }
        Caja other = (Caja) object;
        if ((this.id == null && other.id != null) || (this.id != null && !this.id.equals(other.id))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "bbuvajava.Caja[id=" + id + "]";
    }

   
}

